让Linux更加可用（Accessibility）
================================================================================
一个令人吃惊的事实是，至少十亿人或多或少有着某种程度的残疾。就是说全球大约15%的人在生理上、感知上、心智上会有缺陷，导致他们难以活动、观看、收听以及学习。世界上3.5亿人有不同程度的视觉障碍。计算机技术发展地越快，这些人就越会被疏远，除非计算机软件的开发可以满足他们的需求。

可用性是表示一个产品、设备、服务或者环境在不考虑具体细节的情况下能被多少人使用的程度。可用性可以被看作接触和利用一个系统或者实体的能力。可用性至关重要，社会和谐不是一个慈善行动，而是人类基本的权利。

我们见证了Linux软件和发行版本在使每个人融入社会方面做的突出贡献。举个例子来说，GNOME Accessibility Project 为图形界面用户开发了开源的可用性解决方案。Ubuntu有一个可用性团队致力于使Ubuntu能被更广范围的人使用。不得不提的是Vinux Project，一个基于Ubuntu的发行版本，针对失明和视力有障碍的用户进行了优化。

也有很多单独的应用软件提供了不同的可用性功能。这篇文章试图找出一些顶尖的开源软件，它们能帮助人们充分利用计算机技术，不论他们的生理和知觉功能如何。

让我们了解一下手边的8个通用辅助工具。我们为每个应用编写了它字节的入口页面，完整地、深入地分析了它们的功能，包含截屏和相关资源链接。


### 通用辅助 ###

- [Easystroke][1] 笔画识别软件
- [Simon][2] 	灵活的语音识别软件
- [Orca Screen Reader][3] 	可编程的屏幕阅读器
- [Julius][4] 	Two-pass策略的大词汇持续语音识别引擎
- [Florence Virtual Keyboard][5] 	扩展的可伸缩虚拟键盘
- [Caribou][6] 	可配置的带有扫描模式的屏幕键盘
- [Dasher][7] 	图形化的预测文本输入系统
- [xvkbd][8] 	虚拟（图形）键盘系统

--------------------------------------------------------------------------------

via: http://www.linuxlinks.com/article/20131109042823957/UniversalAccess.html

译者：[boredivan](https://github.com/boredivan) 校对：[wxy](https://github.com/wxy)

本文由 [LCTT](https://github.com/LCTT/TranslateProject) 原创翻译，[Linux中国](http://linux.cn/) 荣誉推出

[1]:http://sourceforge.net/apps/trac/easystroke/
[2]:http://simon-listens.org/
[3]:https://wiki.gnome.org/Orca
[4]:http://julius.sourceforge.jp/
[5]:http://florence.sourceforge.net/english.html
[6]:https://wiki.gnome.org/Caribou
[7]:http://www.inference.phy.cam.ac.uk/dasher/
[8]:http://homepage3.nifty.com/tsato/xvkbd/
