保持自由 - GCC应该接受收费插件吗？
================================================================================

> GCC邮件列表中在争论GCC是否应该接受收费插件，但是认为GCC是一个免费软件开发的媒介的论调占得了上风

Gcc以及它在模块化方面的缺失又一次作为一个问题被提出来，并且和市场上的新的编译器LLVM做了对比。GCC巨大而古老：5百万行代码，30年研发时间，并且还在继续增长。相比较而言，LLVM更加年轻，更加模块化，并且允许所有的语言都作为一个模块添加进去。

LLVM的核心是‘开放源代码’。GCC是反著作权（copyleft）代表，是严格的免费软件，她不允许以任何形式收费的插件的代码进入到GCC的代码中。争论的一种意见，正如Eric Raymond说的，“FSF不可能既阻止持有所有权的供应者添加他们的插件到一个免费编译器中，又让这个编译器得到发展。就像马儿已经偏离了跑道，反对插件策略的战略目标已经彻底的失败了”。

LLVM已经被苹果公司采用作为OS X和苹果硬件上GCC的替代品，并且正在变得流行起来，特别是在BSD系列操作系统的用户中间。LLVM的拥护者推测LLVM将会在更广阔的应用程序和移动设备开发市场上成为GCC的替代者。GCC的反对者们的观点是GCC太过复杂，并且开发者们必须遵守她的‘反著作权（copyleft）’。这限制了那些不想在‘反著作权（copyleft）’许可证下发布他们的语言或者软件产品。作为典型，苹果公司有一个很长的厌恶免费软件的历史。他们也不允许遵守‘反著作权（copyleft）’的软件通过他们的App Store发布。

LLVM和GCC之间的争论其实是GNU/Linux和BSD系列、开放源代码和免费软件之间历史差异的翻新版。开放源码的开发者允许代码被以任何形式的使用，免费或者维持版权。免费软件则严格地规定，代码或者针对代码做的更新，必须保持永久免费。免费软件的支持者认为完整的‘反著作权’授权有助于GCC的发展，并且已经将Linux和免费软件带到一个其他方式无法到达的高度，同时保证了免费软件不会被收购或者堕落成商业利益。开放源码的支持者则认为开放源码更加的自由，因为使用这没有受到限制，他们可以随意使用，包括开发非开源的版本。

GNU编译器集合（GCC）一直是免费软件发展的关键。编译器是稀有且昂贵的商品，版权软件公司也充斥着对不符合标准的特性的需求。让软件兼容不同的机器和操作系统是一个非必需的复杂任务。GCC作为第一个真正免费的跨平台编译器，简化了这个过程。

GCC对于软件开发者和移动设备开发者来说也是一个划时代的产品，而不仅仅对于那些免费软件概念提出者。GCC不但免费和可移植，她跨越不同硬件架构的普遍性和公用性使得更加容易做到软件的兼容性、鲁棒性和一致性。这和John Gilmore，Michael Tiemann和David Henkel-Wallace在开发GCC时发现的一样。这也是Cygnus Solutions公司主要的卖点，Cygnus Solutions是第一家靠卖免费软件赚钱的公司。[译注：Cygnus Solutions是John Gilmore, Michael Tiemann and David Henkel- Wallace创办的公司，同时也是GNU几个主要产品的贡献者]

LLVM和GCC之间主要的技术差异集中在组成‘前端’，‘中端’，‘后端’的模块分割。‘前端’用来翻译特定的语言。‘中端’对翻译后产生的代码进行优化。‘后端’将优化后的代码转化成特定硬件架构的机器码。LLVM将这些模块分割成不同的实体，但是由于语义的和历史的原因，GCC模糊了这些模块之间的界限。

对于一个免费软件项目，添加一种新的语言或者架构到GCC也许是一个非常困难的过程，添加有版权的插件也是不允许的。由于模块间界限非常不明确，最容易的添加方法就是让添加的特性遵循免费软件许可证。最初的开发者也许想保持代码的封闭和版权，但最后不得不将代码以免费软件发布。早期的C++以及Objective C就被认为是其中典型的例子。

与此相反，LLVM允许，甚至也许可以说是鼓励添加和发展版权语言和架构，比如英伟达基于Clang和LLVM的对于GPU开发的NVCC。NVCC的源代码是免费软件或者开源软件开发者获取不到的。

Richard Stallman[对这方面的演讲中][1]旗帜鲜明地宣布：“在免费软件运动中，我们为自由而战。免费软件的的价值观从根本上就和开源软件不同，后者以写‘更好的代码’为终极目标。如果GCC从免费的编译器变成非免费的编译器，她将不再能够达成自由的目标。

“Clang和LLVM的开发者不认可我们的价值观和目标，所以得出了跟我们不一样的结论。他们反对我们采取的捍卫自由的措施，因为他们只看到这对他们造成的不便，却没有看到（或者不关心）他们真正的需求。我猜测他们把他们的工作定义为‘开源’，并且漠视自由。”

GCC开发者们不可能在许可证的条件上妥协。LLVM在某些行业的部门非常流行，因为它很年轻很新，在编程语言的浪潮中跳跃式发展着。流行的风向着更加开放奔跑，GCC决心跟商业利益死磕也许是这个长期演进路上的一大助力。Unix公司们从80和90年代的Unix战争中学到了一些东西。语言和操作系统都是工具，它们最好是开放和共享的。GCC是免费软件，不属于任何人。

--------------------------------------------------------------------------------

via: http://www.linuxuser.co.uk/features/staying-free-should-gcc-allow-non-free-plug-ins

译者：[love\_daisy\_love](https://github.com/CNprober) 校对：[wxy](https://github.com/wxy)

本文由 [LCTT](https://github.com/LCTT/TranslateProject) 原创翻译，[Linux中国](http://linux.cn/) 荣誉推出

[1]:http://lwn.net/articles/582241
