守卫自由的 Linux 世界
================================================================================
![](http://www.linuxinsider.com/ai/908455/open-invention-network.jpg)

**合作是开源的一部分。OIN 的 CEO Keith Bergelt 解释说，开放创新网络（Open Invention Network）模式允许众多企业和公司决定它们该在哪较量，在哪合作。随着开源的演变，“我们需要为合作创造渠道，否则我们将会有几百个团体把数十亿美元花费到同样的技术上。”**

[开放创新网络（Open Invention Network）][1]，即 OIN，正在全球范围内开展让 Linux 远离专利诉讼的伤害的活动。它的努力得到了一千多个公司的热烈回应，它们的加入让这股力量成为了历史上最大的反专利管理组织。

开放创新网络以白帽子组织的身份创建于2005年，目的是保护 Linux 免受来自许可证方面的困扰。包括 Google、 IBM、 NEC、 Novell、 Philips、 [Red Hat][2] 和 Sony 这些成员的董事会给予了它可观的经济支持。世界范围内的多个组织通过签署自由 OIN 协议加入了这个社区。

创立开放创新网络的组织成员把它当作利用知识产权保护 Linux 的大胆尝试。它的商业模式非常的难以理解。它要求它的成员采用免版权许可证，并永远放弃由于 Linux 相关知识产权起诉其他成员的机会。

然而，从 Linux 收购风波——想想服务器和云平台——那时起，保护 Linux 知识产权的策略就变得越加的迫切。

在过去的几年里，Linux 的版图曾经历了一场变革。OIN 不必再向人们解释这个组织的定义，也不必再解释为什么 Linux 需要保护。据 OIN 的 CEO Keith Bergelt 说，现在 Linux 的重要性得到了全世界的关注。

“我们已经见到了一场人们了解到 OIN 如何让合作受益的文化变革，”他对 LinuxInsider 说。

### 如何运作 ###

开放创新网络使用专利权的方式创建了一个协作环境。这种方法有助于确保创新的延续。这已经使很多软件厂商、顾客、新型市场和投资者受益。

开放创新网络的专利证可以让任何公司、公共机构或个人免版权使用。这些权利的获得建立在签署者同意不会专为了维护专利而攻击 Linux 系统的基础上。

OIN 确保 Linux 的源代码保持开放的状态。这让编程人员、设备厂商、独立软件开发者和公共机构在投资和使用 Linux 时不用过多的担心知识产权的问题。这让对 Linux 进行重新打包、嵌入和使用的公司省了不少钱。

“随着版权许可证越来越广泛的使用，对 OIN 许可证的需求也变得更加的迫切。现在，人们正在寻找更加简单或更实用的解决方法”，Bergelt 说。

OIN 法律防御援助对成员是免费的。成员必须承诺不对 OIN 名单上的软件发起专利诉讼。为了保护他们的软件，他们也同意提供他们自己的专利。最终，这些保证将让几十万的交叉许可通过该网络相互连接起来，Bergelt 如此解释道。

### 填补法律漏洞 ###

“OIN 正在做的事情是非常必要的。它提供另一层 IP （知识产权）保护，”[休斯顿法律中心大学][3]的副教授 Greg R. Vetter 这样说道。

他回答 LinuxInsider 说，第二版 GPL 许可证被某些人认为提供了隐含的专利许可，但是律师们更喜欢明确的许可。

OIN 所提供的许可填补了这个空白。它还明确的覆盖了 Linux 内核。据 Vetter 说，明确的专利许可并不是 GPLv2 中的必要部分，但是这个部分被加入到了 GPLv3 中。（LCTT 译注：Linux 内核采用的是 GPLv2 的许可）

拿一个在 GPLv3 中写了10000行代码的代码编写者来说。随着时间推移，其他的代码编写者会贡献更多行的代码，也加入到了知识产权中。GPLv3 中的软件专利许可条款将基于所有参与的贡献者的专利，保护全部代码的使用，Vetter 如此说道。

### 并不完全一样 ###

专利权和许可证在法律结构上层层叠叠互相覆盖。弄清两者对开源软件的作用就像是穿越雷区。

Vetter 说“通常，许可证是授予建立在专利和版权法律上的额外权利的法律结构。许可证被认为是给予了人们做一些的可能会侵犯到其他人的知识产权权利的事的许可。”

Vetter 指出，很多自由开源许可证（例如 Mozilla 公共许可、GNU GPLv3 以及 Apache 软件许可）融合了某些互惠专利权的形式。Vetter 指出，像 BSD 和 MIT 这样旧的许可证不会提到专利。

一个软件的许可证让其他人可以在某种程度上使用这个编程人员创造的代码。版权对所属权的建立是自动的，只要某个人写或者画了某个原创的东西。然而，版权只覆盖了个别的表达方式和衍生的作品。他并没有涵盖代码的功能性或可用的想法。

专利涵盖了功能性。专利权还可以被许可。版权可能无法保护某人如何独立地开发对另一个人的代码的实现，但是专利填补了这个小瑕疵，Vetter 解释道。

### 寻找安全通道 ###

许可证和专利混合的法律性质可能会对开源开发者产生威胁。据 [Chaotic Moon Studios][4] 的创办者之一、 [IEEE][5] 计算机协会成员 William Hurley 说，对于某些人来说，即使是 GPL 也会成为威胁。

“在很久以前，开源是个完全不同的世界。被彼此间的尊重和把代码视为艺术而非资产的观点所驱动，那时的程序和代码比现在更加的开放。我相信很多为最好的愿景所做的努力几乎最后总是背负着意外的结果，”Hurley 这样告诉 LinuxInsider。

他暗示说，成员人数超越了1000人（的组织）可能会在知识产权保护重要性方面意见不一。这可能会继续搅混开源生态系统这滩浑水。

“最终，这些显现出了围绕着知识产权的常见的一些错误概念。拥有几千个开发者并不会减少风险——而是增加。给出了专利许可的开发者越多，它们看起来就越值钱，”Hurley 说。“它们看起来越值钱，有着类似专利的或者其他知识产权的人就越可能试图利用并从中榨取他们自己的经济利益。”

### 共享与竞争共存 ###

竞合策略是开源的一部分。OIN 模型让各个公司能够决定他们将在哪竞争以及在哪合作，Bergelt 解释道。

“开源演化中的许多改变已经把我们移到了另一个方向上。我们必须为合作创造渠道。否则我们将会有几百个团体把数十亿美元花费到同样的技术上，”他说。

手机产业的革新就是个很好的例子。各个公司放出了不同的标准。没有共享，没有合作，Bergelt 解释道。

他说：“这让我们在美国接触技术的能力落后了七到十年。我们接触设备的经验远远落后于世界其他地方的人。在我们用不上 CDMA (Code Division Multiple Access 码分多址访问通信技术)时对 GSM (Global System for Mobile Communications 全球移动通信系统) 还沾沾自喜。”

### 改变格局 ###

OIN 在去年经历了激增400个新许可的增长。这意味着着开源有了新趋势。

Bergelt 说：“市场到达了一个临界点，组织内的人们终于意识到直白地合作和竞争的需要。结果是两件事同时进行。这可能会变得复杂、费力。”

然而，这个由人们开始考虑合作和竞争的文化革新所驱动的转换过程是可以接受的。他解释说，这也是一个人们怎样拥抱开源的转变——尤其是在 Linux 这个开源社区的领导者项目。

还有一个迹象是，最具意义的新项目都没有在 GPLv3 许可下开发。

### 二个总比一个好 ###

“GPL 极为重要，但是事实是有一堆的许可模型正被使用着。在 Eclipse、Apache 和 Berkeley 许可中，专利问题的相对可解决性通常远远低于在 GPLv3 中的。”Bergelt 说。

GPLv3 对于解决专利问题是个自然的补充——但是 GPL 自身不足以独自解决围绕专利使用的潜在冲突。所以 OIN 的设计是以能够补充版权许可为目的的，他补充道。

然而，层层叠叠的专利和许可也许并没有带来多少好处。到最后，专利在几乎所有的案例中都被用于攻击目的——而不是防御目的，Bergelt 暗示说。

“如果你不准备对其他人采取法律行动，那么对于你的知识产权来说专利可能并不是最佳的法律保护方式”，他说。“我们现在生活在一个对软件——开放的和专有的——误会重重的世界里。这些软件还被错误而过时的专利系统所捆绑。我们每天在工业化和被扼杀的创新中挣扎”，他说。

### 法院是最后的手段###

想到 OIN 的出现抑制了诉讼的泛滥就感到十分欣慰，Bergelt 说，或者至少可以说 OIN 的出现扼制了特定的某些威胁。

“可以说我们让人们放下他们的武器。同时我们正在创建一种新的文化规范。一旦你入股这个模型中的非侵略专利，所产生的相关影响就是对合作的鼓励”，他说。

如果你愿意承诺合作，你的第一反应就会趋向于不急着起诉。相反的，你会想如何让我们允许你使用我们所拥有的东西并让它为你赚钱，而同时我们也能使用你所拥有的东西，Bergelt 解释道。

“OIN 是个多面的解决方式。它鼓励签署者创造双赢协议”，他说，“这让起诉成为最逼不得已的行为。那才是它的位置。”

### 底线###

Bergelt 坚信，OIN 的运作是为了阻止 Linux 受到专利伤害。在这个需要 Linux 的世界里没有诉讼的地方。

唯一临近的是与微软的移动之争，这关系到行业的发展前景（原文： The only thing that comes close are the mobile wars with Microsoft, which focus on elements high in the stack. 不太理解，请指正。）。那些来自法律的挑战可能是为了提高包括使用 Linux 产品的所属权的成本，Bergelt 说。

尽管如此“这些并不是有关 Linux 诉讼”，他说。“他们的重点并不在于 Linux 的核心。他们关注的是 Linux 系统里都有些什么。”

--------------------------------------------------------------------------------

via: http://www.linuxinsider.com/story/Defending-the-Free-Linux-World-81512.html

作者：Jack M. Germain
译者：[H-mudcup](https://github.com/H-mudcup)
校对：[wxy](https://github.com/wxy)

本文由 [LCTT](https://github.com/LCTT/TranslateProject) 原创翻译，[Linux中国](http://linux.cn/) 荣誉推出

[1]:http://www.openinventionnetwork.com/
[2]:http://www.redhat.com/
[3]:http://www.law.uh.edu/
[4]:http://www.chaoticmoon.com/
[5]:http://www.ieee.org/
