《道德经》之项目管理
=================================


![](https://opensource.com/sites/default/files/styles/image-full-size/public/images/business/BUSINESS_orgchart1.png?itok=DGsp6jB5)

[道德经][1]，[被认为][2]是由圣人[老子][3]于公元前六世纪时所编写，是现存最为广泛翻译的经文之一。从[宗教][4]到[关于约会的有趣电影][5]等方方面面，它都深深地影响着它们，作者们借用它来做隐喻，以解释各种各样的事情（甚至是[编程][6]）。

在思考有关开放性组织的项目管理时，我的脑海中便立马浮现出上面的这段文字。

这听起来可能会有点奇怪。若要理解我的这种想法从何而来，你应该读读 *《开放性组织：点燃激情提升执行力》* 这本书，它是红帽公司总裁、首席执行官 Jim Whitehurst  所写的一本有关企业文化和新领导力范式的宣言。在这本书中，Jim（还有来自其他红帽人的一点帮助）解释了传统组织机构（一种 “自上而下” 的方式，来自高层的决策被传达到员工，而员工通过晋升和薪酬来激励）和开放性组织机构（一种 自下而上 的方式，领导专注于激励和鼓励，员工被充分授权以各尽其能）之间的差异。

在开放性组织中的员工都是被激情、目标和参与感所激励，这个观点正是我认为项目管理者所应该关注的。

要解释这一切，我将从*道德经*上寻找依据。

### 不要让工作职衔框住自身

> 道，可道也，(The tao that can be told)

> 非恒道也。(is not the eternal Tao)

> 名，可名也，(The name that can be named)

> 非恒名也。(is not the eternal Name.)

> “无”，名天地之始；(The unnameable is the eternally real.)

> “有”，名万物之母。(Naming is the origin of all particular things.)
[[1]][7]

项目管理到底是什么？作为一个项目管理者应该做些什么呢？

如您所想，项目管理者的一部分工作就是管理项目：收集需求、与项目相关人员沟通、设置项目优先级、安排任务、帮助团队解决困扰。许多机构都可以教你如何做好项目管理，并且这些技能你值得拥有。

然而，在开放性组织中，字面上的项目管理技能仅仅只是项目管理者需要做到的一小部分，这些组织需要更多其他的东西：即勇气。如果你擅长于管理项目（或者是真的擅长于任何工作），那么你就进入了舒适区。这时候就是需要鼓起勇气开始尝试冒险之时。

您有勇气跨出舒适区吗？向权威人士提出挑战性的问题，可能会引发对方的不快，但也可能会开启一个更好的方法，您有勇气这样做吗？有确定需要做的下一件事，然后真正去完成它的勇气吗？有主动去解决因为交流的鸿沟而遗留下来的问题的勇气吗？有去尝试各种事情的勇气吗？有失败的勇气吗？

道德经的开篇（上面引用的）就表明词语（words）、标签（labels）、名字（names）这些是有限制的，当然也包括工作职衔。在开放性组织中，项目经理不仅仅是执行管理项目所需的机械任务，而且要帮助团队完成组织的使命，尽管这已经被限定了。

### 联系起合适的人

> 三十辐共一轂，(We join spokes together in a wheel,)

> 当其无，(but it is the center hole)

> 有车之用。(that makes the wagon move.)
[[11]][8]

当我过渡到项目管理的工作时，我必须学会的最为困难的一课是：并不是所有解决方案都是可完全地接受，甚至有的连预期都达不到。这对我来说是全新的一页。我*喜欢*全部都能解决。但作为项目管理者，我的角色更多的是与人沟通--使得那些确实有解决方案的人可以更高效地合作。

这并不是逃避责任或者不负责。这意味着可以很舒适的说，“我不知道，但我会给你找出答案”，然后就可迅速地结束这个循环。

想像一下马车的车轮，如果没有毂中的孔洞所提供的稳定性和方向，辐条便会失去支持，车轮也会散架。在一个开放性的组织中，项目管理者可以通过把合适的人凝聚在一起，培养正确的讨论话题来帮助团队保持持续向前的动力。

### 信任你的团队

>太上，不知有之；(When the Master governs, the people
are hardly aware that he exists.)

> 其次，亲而誉之；(Next best is a leader who is loved.)

> 其次，畏之；(Next, one who is feared.)

> 其次，侮之。(The worst is one who is despised.)

>信不足焉，(If you don't trust the people,)

>有不信焉。(you make them untrustworthy.)

>悠兮，其贵言。(The Master doesn't talk, he acts.)

> 功成事遂，(When his work is done,)

> 百姓皆谓：“我自然”。(the people say, "Amazing:
we did it, all by ourselves!")
[[17]][9]

[Rebecca Fernandez][10] 曾经告诉我开放性组织的领导与其它组织的领导者最大的不同点在于，我们不是去取得别人的信任，而是信任别人。

开放性组织会雇佣那些非常聪明的，且对公司正在做的事情充满激情的人来做工作。为了能使他们能更好的工作，我们会提供其所需，并尊重他们的工作方式。

至于原因，我认为从道德经中摘出的上面一段就说的很清楚。

### 顺其自然

>上德无为而无以为；(The Master does nothing
yet he leaves nothing undone.)

>下德为之而有以为。(The ordinary man is always doing things,
yet many more are left to be done.)
[[38]][11]

你认识那类总是极其忙碌的人吗？认识那些因为有太多事情要做而看起来疲倦和压抑的人吗？

不要成为那样的人。

我知道说比做容易。帮助我没有成为那类人的最重要的东西是：我时刻记着*大家都很忙*这件事。我没有一个那样无聊的同事。

但总需要有人成为在狂风暴雨中仍保持镇定的人。总需要有人能够宽慰团队告诉他们一切都会好起来，我们将在现实和一天中工作时间有限的情况下，找到方法使得任务能够完成（因为事实就是这样的，而且我们必须这样）。

成为那样的人吧。

对于上面这段道德经所说的，我的理解是那些总是谈论他或她正在做什么的人实际上并*没有时间*去做他们谈论的事。如果相比于你周围的人，你能把你的工作做的毫不费劲，那就说明你的工作做对了。

### 做一名文化传教士

>上士闻道，(When a superior man hears of the Tao,)

> 勤而行之；(he immediately begins to embody it.)

> 中士闻道，(When an average man hears of the Tao,)

>若存若亡；(he half believes it, half doubts it.)

> 下士闻道，(When a foolish man hears of the Tao,)

> 大笑之。(he laughs out loud.)

> 不笑不足以為道。(If he didn't laugh,it wouldn't be the Tao.)
[[41]][12]

去年秋天，我和一群联邦雇员参加了一堂 MBA 的商业准则课程。当我开始介绍我们公司的文化、价值和伦理框架时，我得到的直接印象是：我的同学和教授都认为我就像一个天真可爱的小姑娘，做着许多关于公司应该如何运作的[甜美白日梦][13]。他们告诉我事情不可能是他们看起来的那样，他们还告诉我应该进一步考察。

所以我照做了。

然而我发现的是：事情*恰好*是他们看起来的那样。

在开放性组织，关于企业文化，人们应该随着企业的成长而时时维护那些文化，以使它随时精神焕发，充满斗志。我（和其它开源组织的成员）并不想过着如我同学们所描述的那样，“为生活而工作”。我需要有激情、有目标，需要明白自己的日常工作是如何对那些我所坚信的东西做贡献的。

作为一个项目管理者，你可能会认为在你的团队中，你的工作对培养你们公司的企业文化没有多少帮助。然而你的工作正是孕育文化本身。

### Kaizen (持续改善)

>为学日益，(In pursuit of knowledge,every day something is added.)

> 为道日损。(In the practice of the Tao,every day something is dropped.)

> 损之又损，(Less and less do you need to force things,)

> 以至于无为。(until finally you arrive at non-action. )

> 无为而无不为。(When nothing is done,nothing is left undone.)
[[48]][14]

项目管理的常规领域都太过于专注最新、最强大的的工具，但对于应该使用哪种工具，这个问题的答案总是一致的：“最简单的”。

例如，我将任务列表放在桌面的一个文本文件中，因为它很单纯，不会受到不必要的干扰。您想介绍给团队的，无论是何种工具、流程和程序都应该是能提高效率，排除障碍的，而不是引入额外的复杂性。所以与其专注于工具，还不如专注于要使用这些工具来解决的*问题*。

作为一个项目经理，我最喜爱的部分是在敏捷世界中，我有自由抛弃那些没有成效的东西的权利。这与 [kaizen][16] 的概念相关，或叫 “持续改进”。不要害怕尝试和失败。失败是我们在探索什么能够起作用，什么不能起作用的过程中所用的标签，这是提高的唯一方式。

最好的过程都不是一蹴而就的。作为项目管理者，你应该通过支持他们，而不是强迫他们去做某些事来帮助你的团队。

### 实践

>天下皆谓我"道"大，(Some say that my teaching is nonsense.)

> 似不肖。(Others call it lofty but impractical.)

> 夫唯大，(But to those who have looked inside themselves,)

> 故似不肖。(this nonsense makes perfect sense.)

>若肖，(And to those who put it into practice,)

> 久矣其细也夫！(this loftiness has roots that go deep.)
[[67]][15]

我相信开放性组织正在做的事。开放性组织在管理领域的工作几乎与他们提供的产品和服务一样重要。我们有机会以身作则，激发他人的激情和目的，创造激励和充分授权的工作环境。

我鼓励你们找到办法把这些想法融入到自己的项目和团队中，看看会发生什么。了解你们组织的使命，知晓你的项目是如何为这个使命做贡献的。鼓起勇气，尝试某些看起来没有多少成效的事，同时不要忘记和我们的社区分享你所学到的经验，这样我们就可以继续改进。

--------------------------------------------------------------------------------

via: https://opensource.com/open-organization/16/2/tao-project-management

作者：[Allison Matlack][a]
译者：[runningwater](https://github.com/runningwater)
校对：[FSSlc](https://github.com/FSSlc)

本文由 [LCTT](https://github.com/LCTT/TranslateProject) 原创编译，[Linux中国](https://linux.cn/) 荣誉推出

[a]: https://opensource.com/users/amatlack
[1]: http://acc6.its.brooklyn.cuny.edu/~phalsall/texts/taote-v3.html
[2]: https://en.wikipedia.org/wiki/Tao_Te_Ching
[3]: http://plato.stanford.edu/entries/laozi/
[4]: https://en.wikipedia.org/wiki/Taoism
[5]: http://www.imdb.com/title/tt0234853/
[6]: http://www.mit.edu/~xela/tao.html
[7]: http://acc6.its.brooklyn.cuny.edu/~phalsall/texts/taote-v3.html#1
[8]: http://acc6.its.brooklyn.cuny.edu/~phalsall/texts/taote-v3.html#11
[9]: http://acc6.its.brooklyn.cuny.edu/~phalsall/texts/taote-v3.html#17
[10]: https://opensource.com/users/rebecca
[11]: http://acc6.its.brooklyn.cuny.edu/~phalsall/texts/taote-v3.html#38
[12]: http://acc6.its.brooklyn.cuny.edu/~phalsall/texts/taote-v3.html#41
[13]: https://opensource.com/open-organization/15/9/reflections-open-organization-starry-eyed-dreamer
[14]: http://acc6.its.brooklyn.cuny.edu/~phalsall/texts/taote-v3.html#48
[15]: http://acc6.its.brooklyn.cuny.edu/~phalsall/texts/taote-v3.html#67
[16]: https://www.kaizen.com/about-us/definition-of-kaizen.html