2017 年成为 Linux 专家的 4 个热门技能
============================================================

### 你在新的一年里需要刷哪些技能？

![4 hot skills for Linux pros in 2017](https://opensource.com/sites/default/files/styles/image-full-size/public/images/business/lightbulb-idea-think-yearbook-lead.png?itok=56ovNk8n "4 hot skills for Linux pros in 2017") 

图片提供：[Internet Archive Book Images][1]。由 Opensource.com 修改。 CC BY-SA 4.0

成为 Linux 专家的一个问题是“专家”的定义在不断变化。当我进入 Linux 世界的时候，那时认为成为一个 _Linux 专家_，你需要能够编译自己的内核。天啊，如果你想在笔记本电脑上使用 Linux，即便你只是_用户_，你也必须编译一个自定义内核。 如今编译自己的内核通常是浪费时间。这不是说它并不重要，但在开源世界，我们建立在他人成功的基础之上，而 Linux 发行版为我们提供了运行良好的内核。虽然“专家”的定义并不总是那么剧烈变化，但对 IT 专业人员的需求每年都在变化。

下面是 2017 年 Linux 专业人员的四个重要技能：

### 1、 安全

我不是在讨论安全专家或安全顾问。这些职位和服务当然很重要，但是随着联网设备渗透到我们生活的每一个方面，我们需要在我们做出的每一个决定中都具有[安全][2]意识。今年，我的妻子和我买了一台洗衣机和一台冰箱，它们都配备了蓝牙。黑客攻入我的漂洗系统的想法可能看起来很傻，但这都是潜在的攻击点。

当激活工作、家庭或我们的口袋中的任何系统时，我们应该考虑它们可能引发的安全问题。而且因为像联网烤面包机这样的物品不太可能及时获得固件升级，我们需要按照普通设备可能遭到破坏的思路来设计其余的系统。相比以前任何时候，我们更需要考虑来自防火墙内的攻击。不要让你的文件服务器被你的搅拌器破坏！

### 2、 DevOps

[DevOps][3] 不再是一个新概念。在过去两三年里，我们一直鼓励员工学习 DevOps，以便他们能够在工作中取得成功。这是个好建议，但这并不意味着我们应该完全依赖自动化工具来完成我们的工作。Chef、Puppet、Ansible、Salt Stack 及类似的工具是美好的，但我们需要了解背后发生了什么，所以当发生一些不可避免的错误，我们应该知道如何解决它。

使用 DevOps 的编程方法来计算，我们仍然需要能够维护、修复和理解在代码层之下运行的系统的人。没有 Linux 专家，云计算将是一个可怕的地方，即使那个云在你自己的机房里。

### 3、 开发

作为系统管理员，20 年来，我从来没有时间学习编程。这听起来可能是一个借口，但这是事实。我所有的开发技能就是基本的脚本编写，以帮助我更快工作。不过，那些日子已经结束了。虽然我们需要在 DevOps 世界中拥有系统管理技能，但我们还需要系统管理员拥有编程技能。

如果你是一个像我一样的老练的系统管理员，你可能已经采用 DevOps 并每天使用它。如果你真的想要胜过他人，你需要学习如何以编程方式解决问题，并且不要认为 Chef 或 Puppet 代码只是配置文件。 每个 IT 专业人员都至少需要掌握编程的概念，因为 DevOps 代码至少在某种程度上抽象了 IT 的每个方面。

### 4、 软技能

通常，我们在准备职业生涯时所考虑的最后一件事是所谓的 *软技能* - 社交和沟通技巧 - 但是它们可能是最有可能决定你走向成功的技能。无论你正在寻找一份新工作，还是试图适应当前职业生涯的变化，软技能是至关重要的。

划分 IT 各个领域的标准是交错的，并且良好的沟通能力使得这些模糊的分野成为一个有利条件，而不是绊脚石。我们正生活在一个开发人员围绕着服务器，而运维团队编写 Ruby 代码来维护服务器农场的世界里。这些都是 IT 中的大胆的新思想，如果人们不能在不同部门间很好的沟通，工作场所将迅速有敌对气氛。此外，IT 人员总是需要与其他业务领域的人员进行有效沟通。而且，现在比以往有更大的需求。


你计划在 2017 年里添加什么到你的技能中？在评论栏中让我们知道吧。

--------------------------------------------------------------------------------

作者简介：

![](https://opensource.com/sites/default/files/styles/profile_pictures/public/Shawn%20Powers%20350%20x%20250%20px_2.jpg?itok=6n0E_-Z2)

Shawn Powers - 自 2009 年起是 CBT Nuggets (www.cbtnuggets.com) 的一名 IT 训练员，专于 Linux、Chef 及为大规模网络集成多个平台。他在 2016 年 12 月发布了一个在线高级 Linux 认证课程（LPIC-2）。

--------------------------------------------------------------------------------

via: https://opensource.com/article/17/1/yearbook-4-hot-skills-linux-pros-2017

作者：[Shawn Powers][a]
译者：[geekpi](https://github.com/geekpi)
校对：[jasminepeng](https://github.com/jasminepeng)

本文由 [LCTT](https://github.com/LCTT/TranslateProject) 原创编译，[Linux中国](https://linux.cn/) 荣誉推出

[a]:https://opensource.com/users/shawnpowers
[1]:https://www.flickr.com/photos/internetarchivebookimages/14758810172/in/photolist-oubL5m-ocu2ck-odJwF4-oeq1na-odgZbe-odcugD-w7KHtd-owgcWd-oucGPe-oud585-rgBDNf-obLoQH-oePNvs-osVgEq-othPLM-obHcKo-wQR3KN-oumGqG-odnCyR-owgLg3-x2Zeyq-hMMxbq-oeRzu1-oeY49i-odumMM-xH4oJo-odrT31-oduJr8-odX8B3-obKG8S-of1hTN-ovhHWY-ow7Scj-ovfm7B-ouu1Hj-ods7Sg-qwgw5G-oeYz5D-oeXqFZ-orx8d5-hKPN4Q-ouNKch-our8E1-odvGSH-oweGTn-ouJNQQ-ormX8L-od9XZ1-roZJPJ-ot7Wf4
[2]:https://opensource.com/tags/security
[3]:https://opensource.com/tags/devops
