开放组织公开追踪问题的好处
============================================================

> 在开放组织中，在线追踪问题可以将客户转变成伙伴。

 ![The benefits of tracking issues publicly](https://opensource.com/sites/default/files/styles/image-full-size/public/images/life/OSDC_bees_network.png?itok=Ims9tFQS "The benefits of tracking issues publicly") 

一个公开的问题追踪器是开放组织的重要沟通工具，和在公开渠道中开展工作相比，没有比这种方式更[透明和包容][6]的方式了。因此，让我们来探讨一下在开放组织中使用问题跟踪器的一些最佳实践。

在开始之前，我们先来定义“<ruby>问题追踪器<rt>issue tracker</rt></ruby>”的含义。简单地说，问题跟踪器是**一个共享的待办事项列表**。想象一下一张胡乱写的待办事项列表：购买面包、邮件打包、归还图书馆书籍。当你在城里开车时，把列表上的每一项划掉的感觉很好。现在，将它扩展到你需要在组织中完成的工作，并增加合适的软件协作能力。这样你就有一个问题追踪器了！

无论你使用的是 GitHub 还是其他的，如 Bitbucket、GitLab 或 Trello，问题跟踪器都是与你的伙伴进行协调的正确工具。这对将外部人员_变成_伙伴是至关重要的，这是开放组织的特征之一。那么这是如何工作的？我很高兴你问了这个问题。

### 使用问题追踪器的最佳实践

使用公共问题跟踪器将外部人员转换为伙伴的最佳实践是基于过去五年来我们在 [Gratipay][7] 的经验。我们帮助公司和其他组织为开源买单，我们喜欢使用我们的问题跟踪器与我们的社区合作。这就是我们所学到的。

**0、 隐私优先。** 在这篇文章中谈论公共问题追踪器的隐私看上去是一个奇怪的开始。但是我们必须记住，[开放本身并不是目的][8]，任何真诚和真正的开放是建立在安全和认可的坚实基础之上的。不要公开发布客户或其他第三方私下给你的信息，除非你明确提出了要求并且得到了他们的明确同意。采纳一个隐私政策并培训你的人员。[这篇 Gratipay 的政策][9]可供参考。好的！现在这部分清楚之后，让我们继续。

**1、 默认采用公开决策。** 如果你私下做决策，你就会失去运行一个开放组织的好处，比如表达多样化的想法、招募有活力的人才、实现更大的责任感。即使你的全职员工是最初使用你的公共问题跟踪器的唯一员工，那也要这么做。 避免将你的公共问题追踪器视为二等公民。如果你在办公室进行对话，请在公共问题跟踪器上发布摘要，并在最终决策之前给你的社区留出时间来响应。这是使用问题跟踪器解锁你组织开放权力的第一步：如果它不在问题追踪器中，那就没用！

**2、 关联其他工具。** 我们许多人都喜欢 IRC 和 Slack，这并不是什么秘密。或者你的组织已经使用 Trello，但是你也想开始使用 GitHub。这没问题！在 GitHub issue 中放入 Trello 卡片的链接很容易，反之亦然。交叉关联保证了被一个或另一个问题困住的外部人员能够发现帮助它们充分理解这个问题的更多相关信息。对于聊天服务，你可能需要配置公共日志记录才能维护关联（隐私注意事项：当你这么做时，请务必在你的频道描述中宣传该事实）。也就是说，你应该在私人 Slack 或其他私人渠道中对话，就像在办公室里面对面的对话一样。换句话说，一定要总结公众问题跟踪器上的对话。看看上面说的：无论离线或在线，如果不在问题跟踪器中，那就没用！

**3、 将谈话导向追踪器中。** 社交媒体很快就能获得很多反馈，尤其是发现问题，但这不是解决问题的地方。问题跟踪器为深入的对话和分析根本原因留出了空间。更重要的是，它们是为了完成任务而优化的，而不是无限拖延。当问题解决后点击“关闭”按钮的感觉真的很好！现在将公共问题跟踪器作为你的主要工作场所，你可以开始邀请在社交媒体上与你接触的外部人员在追踪器中进一步地讨论。简单的如，“感谢您的反馈！听起来像是（某个公共问题的链接）？” ，这可以在很大程度上向外界传达你的组织没有隐藏的内容，并欢迎他们的参与。

**4、 设置一个“元”追踪器。** 在一开始，你的问题追踪器很自然聚焦在_具体产品_上。当你准备好开放到一个新的水平时，考虑设置一个关于你的_组织_本身的问题跟踪。在 Gratipay，我们有一个称之为 “Inside Gratipay”的公共问题追踪器，我们愿意在其中讨论我们组织的任何方面，从[我们的预算][10]到[我们的法律结构][11]到[我们的名字][12]。 是的，这有时有点混乱 —— 重命名组织是一个特别激烈的[争议话题][13]！但对我们来说，在社区参与方面的好处是值得的。

**5、 将你的元追踪器用于加入过程。** 一旦你有一个元问题追踪器，就有了一个新的加入过程：邀请潜在的伙伴创建自己的入场券。如果他们以前从未使用过你的特定的问题追踪器，那么这将是他们学习的极好机会。注册帐号并提交问题应该很简单（如果不是，请考虑切换工具！）。这将让你的新伙伴尽早跨过门槛，开始分享参与感，并在组织内部拥有一席之地。当然，没有问题是愚蠢的，尤其是在某个人的入场券中更是如此。这是你的新伙伴熟悉组织工作方式时询问任何问题的地方。你需要确保快速回复他们的问题，让他们参与并帮助他们融入你的组织。这也是一个很好的方法来记录你最终授予这个人的各种系统的访问权限。至关重要的是，这可以[在雇佣他们之前][14]开始。

**6、 雷达项目。** 大多数问题跟踪器包括一些组织和排序任务的方法。例如，GitHub 有[里程碑][15]和[项目][16]。这些通常旨在使组织成员的工作重点相一致。在 Gratipay，我们发现使用这些工具可以帮助协作者拥有并排序各自的工作重点。与其它的问题跟踪器通常提供的将问题分配给特定个人的做法不同，我们发现这一点提供了不同的价值。 我可能会关心别人正在积极工作的问题，或者我可能有兴趣开始某些事情，但别人先提出来我也很高兴。拥有自己的项目空间来组织我对该组织的工作的看法是与我的伙伴们沟通“我的雷达上有什么”的强大方式。

**7、 使用机器人自动化任务。** 最终，你可能会发现某些任务会一再出现。这表明自动化可以简化你的工作流程。在 Gratipay，我们[构建][17]了一个[机器人][18]帮助我们完成一些重复的任务。诚然，这是一个有点高级的用法。如果你达到了这一点，你能完全使用公共问题追踪器来开放你的组织！

如 Jim Whitehurst 所说 “吸引社区内外参与” ，这些是我们在 Gratipay 内使用我们的问题跟踪器的一些最有用的做法。也就是说，我们一直在学习。如果你有自己的经验分享，请发表评论！

（题图：opensource.com）

--------------------------------------------------------------------------------


作者简介：

Chad Whitacre - 我是 Gratipay 的创始人，Gratipay 是一个开放组织，致力于培育一个感恩、慷慨和爱的经济。我们帮助公司和其它组织为开源买单，以及赞助我们的平台。在线下，我居住在美国宾夕法尼亚州匹兹堡，在线上，我活跃在 GitHub。

--------------------------------------------------------------------------------

via: https://opensource.com/open-organization/17/2/tracking-issues-publicly

作者：[Chad Whitacre][a]
译者：[geekpi](https://github.com/geekpi)
校对：[wxy](https://github.com/wxy)

本文由 [LCTT](https://github.com/LCTT/TranslateProject) 原创编译，[Linux中国](https://linux.cn/) 荣誉推出

[a]:https://opensource.com/users/whit537
[1]:https://opensource.com/open-organization/resources/leaders-manual?src=too_resource_menu
[2]:https://opensource.com/open-organization/resources/field-guide?src=too_resource_menu
[3]:https://opensource.com/open-organization/resources/open-org-definition?src=too_resource_menu
[4]:https://opensource.com/open-organization/resources/open-decision-framework?src=too_resource_menu
[5]:https://opensource.com/open-organization/17/2/tracking-issues-publicly?rate=S5mrFkcwQzkErQQMkHYyaaMxF5j5xtZBHW91EPluD1A
[6]:https://opensource.com/open-organization/resources/open-org-definition
[7]:https://gratipay.com/
[8]:https://opensource.com/open-organization/16/9/openness-means-to-what-end
[9]:http://inside.gratipay.com/howto/seek-consent
[10]:https://github.com/gratipay/inside.gratipay.com/issues/928
[11]:https://github.com/gratipay/inside.gratipay.com/issues/72
[12]:https://github.com/gratipay/inside.gratipay.com/issues/73
[13]:http://bikeshed.com/
[14]:https://opensource.com/open-organization/16/5/employees-let-them-hire-themselves
[15]:https://help.github.com/articles/creating-and-editing-milestones-for-issues-and-pull-requests/
[16]:https://help.github.com/articles/about-projects/
[17]:https://github.com/gratipay/bot
[18]:https://github.com/gratipay-bot
[19]:https://opensource.com/user/73891/feed
[20]:https://opensource.com/users/whit537
