我号召黑客新闻的理由之一
实现高速缓存会花费 30 个小时，你有额外的 30 个小时吗？
不，你没有。
我实际上并不知道它会花多少时间，可能它会花五分钟，你有五分钟吗？不，你还是没有。为什么？因为我在撒谎。它会消耗远超五分钟的时间，这是程序员永远的
乐观主义。
- Owen Astrachan 教授于 2004 年 2 月 23 日在 CPS 108 上的讲座

指责开源软件的使用存在着高昂的代价已经不是一个新论点了，它之前就被提过，而且说的比我更有信服力，即使一些人已经在高度赞扬开源软件的运作。
这种事为什么会重复发生？

在周一的黑客新闻上，我愉悦地看着某些人一边说写 Stack Overflow 简单的简直搞笑，一边通过允许七月第四个周末之后的克隆来开始备份他们的提问。
其他的声明中也指出现存的克隆是一个好的出发点。

让我们假设，为了争辩，你觉得将自己的 Stack Overflow 通过 ASP.NET 和 MVC 克隆是正确的，然后被一块廉价的手表和一个小型俱乐部头领忽悠之后，
决定去手动拷贝你 Stack Overflow 的源代码，一页又一页，所以你可以逐字逐句地重新输入，我们同样会假定你像我一样打字，很酷的有 100 WPM 
（差不多每秒8个字符），不和我一样的话，你不会犯错。

 Stack Overflow 的 *.cs、*.sql、*.css、*.js 和 *.aspx 文件大约 2.3 MB，因此如果你想将这些源代码输进电脑里去的话，即使你不犯错也需要大约 80 个小时。

除非......当然，你是不会那样做的：你打算从头开始实现 Stack Overflow 。所以即使我们假设，你花了十倍的时间去设计、输出，然后调试你自己的实现而不是去拷
贝已有的那份，那已经让你已经编译了好几个星期。我不知道你，但是我可以承认我写的新代码大大小于我复制的现有代码的十分之一。

好，ok，我听见你松了口气。所以不是全部。但是我可以做大部分。

行，所以什么是大部分？这只是询问和回答问题，这个部分很简单。那么，除了你必须实现对问题和答案投票、赞同还是反对，而且提问者应该能够去接收每一个问题的
单一答案。你不能让人们赞同或者反对他们自己的回答。所以你需要去阻止。你需要去确保用户在一定的时间内不会赞同或反对其他用户太多次。以预防垃圾邮件，
你可能也需要去实现一个垃圾邮件过滤器，即使在一个基本的设计里，也要考虑到这一点。而且还需要去支持用户图标。并且你将不得不寻找一个自己真正信任的并且
与 markdown 接合很好的 HTML 库（当然，你确实希望重新使用那个令人敬畏的编辑器 Stack Overflow ），你还需要为所有控件购买，设计或查找小部件，此外
你至少需要一个基本的管理界面，以便用户可以调节，并且你需要实现可扩展的业务量，以便能稳定地给用户越来越多的功能去实现他们想做的。

如果你这样做了，你可以完成它。

除了...除了全文检索外，特别是它在“寻找问题”功能中的表现，这是必不可少的。然后用户的基本信息，和回答的意见，然后有一个主要展示你的重要问题，
但是它会稳定的冒泡式下降。另外你需要去实现奖励，并支持每个用户的多个 OpenID 登录，然后为相关的事件发送邮件通知，并添加一个标签系统，
接着允许管理员通过一个不错的图形界面配置徽章。你需要去显示用户的 karma 历史，点赞和差评。整个事情的规模都非常好，因为它随时都可以被
 slashdotted、reddited 或是 Stack Overflow 。

在这之后！你就已经完成了！

...在正确地实现升级、国际化、业绩上限和一个 css 设计之后，使你的站点看起来不像是一个屁股，上面的大部分 AJAX 版本和 G-d 知道什么会同样潜伏
在你所信任的界面下，但是当你开始做一个真正的克隆的时候，就会遇到它。

告诉我：这些功能中哪个是你感觉可以削减而让它仍然是一个引人注目的产品，哪些是大部分网站之下的呢？哪个你可以剔除呢？

开发者因为开源软件的使用是一个可怕的痛苦这样一个相同的理由认为克隆一个像 Stack Overflow 的站点很简单。当你把一个开发者放在 Stack Overflow 前面，
他们并不真的看到 Stack Overflow，他们实际上看的是这些:

create table QUESTION (ID identity primary key,
                       TITLE varchar(255), --- 为什么我知道你认为是 255
                       BODY text,
                       UPVOTES integer not null default 0,
                       DOWNVOTES integer not null default 0,
                       USER integer references USER(ID));
create table RESPONSE (ID identity primary key,
                       BODY text,
                       UPVOTES integer not null default 0,
                       DOWNVOTES integer not null default 0,
                       QUESTION integer references QUESTION(ID))

如果你告诉一个开发者去复制 Stack Overflow ，进入他脑海中的就是上面的两个 SQL 表和足够的 HTML 文件来显示它们，而不用格式化，这在一个周末里是完全
可以实现的，聪明的人会意识到他们需要实现登陆、注销和评论，点赞需要绑定到用户。但是这在一个周末内仍然是完全可行的。这仅仅是在 SQL 后端里加上两张
左右的表，而 HTML 则用来展示内容，使用像 Django 这样的框架，你甚至可以免费获得基本的用户和评论。

但是那不是和 Stack Overflow 相关的，无论你对 Stack Overflow 的感受如何，大多数访问者似乎都认为用户体验从头到尾都很流畅，他们感觉他们和一个
好产品相互影响。即使我没有更好的了解，我也会猜测 Stack Overflow 在数据库模式方面取得了持续的成功-并且有机会去阅读 Stack Overflow 的源代码，
我知道它实际上有多么的小，这些是一个极大的 spit 和 Polish 的集合，成为了一个具有高可用性的主要网站，一个开发者，问一个东西被克隆有多难，
仅仅不认为和 Polish 相关，因为 Polish 是实现结果附带的。

这就是为什么 Stack Overflow 的开放源代码克隆会失败，即使一些人在设法实现大部分 Stack Overflow 的“规范”，也会有一些关键区域会将他们绊倒，
举个例子，如果你把目标市场定在了终端用户上，你要么需要一个图形界面去配置规则，要么聪明的开发者会决定哪些徽章具有足够的通用性，去继续所有的
安装，实际情况是，开发者发牢骚和抱怨你不能实现一个真实的综合性的像 badges 的图形用户界面，然后 bikeshed 任何的建议，为因为标准的 badges 
在范围内太远，他们会迅速避开选择其他方向，他们最后会带着相同的有 bug 追踪器的解决方案赶上，就像他们工作流程的概要使用一样：
开发者通过任意一种方式实现一个通用的机制，任何一个人完全都能轻松地使用 Python、PHP 或任意一门语言中的系统 API 来工作，能简单为他们自己增加
自定义设置，PHP 和 Python 是学起来很简单的，并且比起曾经的图形界面更加的灵活，为什么还要操心其他事呢？

同样的，节制和管理界面可以被削减。如果你是一个管理员，你可以进入 SQL 服务器，所以你可以做任何真正的管理-就像这样，管理员可以通过任何的 Django 
管理和类似的系统给你提供支持，因为，毕竟只有少数用户是 mods，mods 应该理解网站是怎么运作、停止的。当然，没有 Stack Overflow 的接口失败会被纠正
，即使 Stack Overflow 的愚蠢的要求，你必须知道如何去使用 openID （它是最糟糕的缺点）最后得到修复。我确信任何的开源的克隆都会狂热地跟随它-
即使 GNOME 和 KDE 多年来亦步亦趋地复制 windows ，而不是尝试去修复它自己最明显的缺陷。

开发者可能不会关心应用的这些部分，但是最终用户会，当他们尝试去决定使用哪个应用时会去考虑这些。就好像一家好的软件公司希望通过确保其产品在出货之前
是一流的来降低其支持成本一样，所以，同样的，懂行的消费者想在他们购买这些产品之前确保产品好用，以便他们不需要去寻求帮助，开源产品就失败在这种地方
，一般来说，专有解决方案会做得更好。

这不是说开源软件没有他们自己的立足之地，这个博客运行在 Apache，Django，PostgreSQL 和 Linux 上。但是让我告诉你，配置这些堆栈不是为了让人心灰意懒
，PostgreSQL 需要在老版本上移除设置。然后，在 Ubuntu 和 FreeBSD 最新的版本上，仍然要求用户搭建第一个数据库集群，MS SQL不需要这些东西，Apache...
天啊，甚至没有让我开始尝试去向一个初学者用户解释如何去得到虚拟机，MovableType，一对 Django 应用程序，而且所有的 WordPress 都可以在一个单一的安装下
顺利运行，像在地狱一样，只是试图解释 Apache 的分叉线程变换给技术上精明的非开发人员就是一个噩梦，IIS 7 和操作系统的 Apache 服务器是非常闭源的，
图形界面管理程序配置这些这些相同的堆栈非常的简单，Django 是一个伟大的产品，但是它只是基础架构而已，我认为开源软件做的很好，恰恰是因为推动开发者去
贡献的动机

下次你看见一个你喜欢的应用，认为所有面向用户的细节非常长和辛苦，就会去让它用起来更令人开心，在谴责你如何能普通的实现整个的可恶的事在一个周末，
十分之九之后，当你认为一个应用的实现简单地简直可笑，你就完全的错失了故事另一边的用户

via: https://bitquabit.com/post/one-which-i-call-out-hacker-news/

作者：Benjamin Pollack 译者：hopefully2333 校对：校对者ID

本文由 LCTT 原创编译，Linux中国 荣誉推出
